## artyfx-1.3.1-1.src.tar.gz

=== CMakeLists.txt ===

cmake_minimum_required (VERSION 2.6)

project (artyfx)

#set(ARTYFX_VERSION_MAJOR "1")
#set(ARTYFX_VERSION_MINOR "3")
#set(ARTYFX_VERSION_PATCH "0")

#set(ARTYFX_VERSION "${ARTYFX_VERSION_MAJOR}.${ARTYFX_VERSION_MINOR}\
#.${ARTYFX_VERSION_PATCH}")

option(RELEASE_BUILD  "Build for production usage" ON  )
option(BUILD_GUI      "Build GUI (AVTK based)"     ON  )
option(BUILD_SSE      "Build with SSE flags"       ON  )
option(BUILD_BENCH    "Build benchmarks binary"    OFF )

find_package(PkgConfig)

pkg_check_modules(LV2 lv2>=1.8.0 REQUIRED)
include_directories( ${LV2_INCLUDE_DIRS}  )

pkg_check_modules(SND sndfile REQUIRED)
include_directories( ${SND_INCLUDE_DIRS}  )
#target_link_libraries( avtkDemo ${CAIRO_LIBRARIES}  )

SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fPIC -shared -L./src/avtk")
if(NOT APPLE)
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
endif()
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -O1 -Wno-unused-variable")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -O1 -Wno-unused-variable -ftree-vectorize")

# DSP sources
FILE(GLOB sources src/dsp/*.cxx src/dsp/rr/*.cxx  src/dsp/eq/*.cc )

IF(BUILD_SSE)
  IF(NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")
    SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} -msse2 -mfpmath=sse")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse")
  ENDIF()
ENDIF()

IF(BUILD_GUI)
  # TODO: when building GUI, add platform checks for X11, Win, OsX
  #pkg_check_modules(X11 x11 REQUIRED)
  #include_directories( ${NTK_INCLUDE_DIRS}  )
  #link_directories   ( ${NTK_LIBRARY_DIRS}  )
  #SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DPUGL_HAVE_CAIRO")
  #SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DPUGL_HAVE_CAIRO")
  FILE(GLOB ui_sources src/ui/*.cxx src/ui/graphs/*.cxx )
  # AVTK .a static library build
  add_subdirectory (src/avtk)
  include_directories("src/avtk/avtk/")
ENDIF()

string( ASCII 27 _esc)
function(COLOR_MESSAGE TEXT)
    if(CMAKE_COLOR_MAKEFILE)
        MESSAGE(${TEXT})
    else()
        string(REGEX REPLACE "${_esc}.[0123456789;]*m" "" __TEXT ${TEXT} )
        MESSAGE(${__TEXT})
    endif()
endfunction()

SET(green     "${_esc}[1;32m")
SET(blue      "${_esc}[1;34m")
SET(reset     "${_esc}[1;0m")

COLOR_MESSAGE( "
  ${blue}ArtyFX Configuration : ${ARTYFX_VERSION}${reset}
-----------------------
* ${green}Install Directory${reset}               : ${CMAKE_INSTALL_PREFIX}
* ${green}AVTK GUI${reset}                        : ${BUILD_GUI}
* ${green}DSP Benchmarks${reset}                  : ${BUILD_BENCH}
")

ADD_LIBRARY(artyfx SHARED ${sources} )

target_link_libraries( artyfx LINK_PUBLIC ${SND_LIBRARIES}   )
target_link_libraries( artyfx LINK_PUBLIC "-lpthread" )

IF(BUILD_GUI)
  ADD_LIBRARY( artyfx_ui SHARED ${ui_sources} )
  add_dependencies( artyfx_ui avtk )
  target_link_libraries( artyfx_ui "-lavtk -lcairo -lX11" )
  set_target_properties( artyfx_ui PROPERTIES PREFIX "")
  install (TARGETS artyfx_ui DESTINATION lib/lv2/artyfx.lv2/)
ENDIF()

IF(BUILD_BENCH)
  add_executable (artyfx_benchmark src/dsp/perf_test.cpp )
  target_link_libraries(artyfx_benchmark "-lbenchmark -lpthread" )
ENDIF()

# Remove "lib" part before name (artyfx.so, not libartyfx.so)
set_target_properties(artyfx PROPERTIES PREFIX "")

# add the install targets
install (TARGETS artyfx    DESTINATION lib/lv2/artyfx.lv2/)

FILE(GLOB modF "artyfx.lv2/modgui/*")
FILE(GLOB ttls "artyfx.lv2/*.ttl"   )

install(FILES     ${modF} DESTINATION lib/lv2/artyfx.lv2/modgui/)
install(FILES     ${ttls} DESTINATION lib/lv2/artyfx.lv2/)

=== src/avtk/CMakeLists.txt ===

cmake_minimum_required (VERSION 2.6)

project (AVTK)

set(AVTK_VERSION_MAJOR "0")
set(AVTK_VERSION_MINOR "0")
set(AVTK_VERSION_PATCH "1")

set(AVTK_VERSION "${AVTK_VERSION_MAJOR}.${AVTK_VERSION_MINOR}.${AVTK_VERSION_PATCH}")

option(AVTK_RELEASE_BUILD   "Build for releasing"          ON  )
option(AVTK_DEBUG_PRINTS    "Build with debugging prints"  OFF )
option(AVTK_DEMO_AND_TEST   "Build demo and test programs" OFF )
option(AVTK_SNDFILE_SUPPORT "Build with sndfile library"   OFF )
option(AVTK_TESTER_SUPPORT  "Build with Tester Rec/Play"   OFF )




################################################################################
### Code compilation starts here
################################################################################

ADD_DEFINITIONS( "-DAVTK_VERSION_STRING=\"${AVTK_VERSION}\"" )

include_directories ("${PROJECT_SOURCE_DIR}/avtk/")

find_package(PkgConfig)

IF(AVTK_TESTER_SUPPORT)
  ADD_DEFINITIONS( "-DAVTK_TESTER" )
ENDIF()

IF(AVTK_DEBUG_PRINTS)
  ADD_DEFINITIONS( "-DAVTK_DEBUG" )
  #ADD_DEFINITIONS( "-DAVTK_DEBUG_DTOR" )
  #ADD_DEFINITIONS( "-DAVTK_DEBUG_FILE_OPS" )
ENDIF()

IF( AVTK_SNDFILE_SUPPORT )
  ADD_DEFINITIONS( "-DAVTK_SNDFILE" )
  pkg_check_modules(SNDFILE sndfile REQUIRED)
  include_directories( ${SNDFILE_INCLUDE_DIRS})
  link_directories   ( ${SNDFILE_LIBRARY_DIRS})
ENDIF()

ADD_DEFINITIONS( "-DPUGL_HAVE_CAIRO" )
pkg_check_modules(CAIRO cairo REQUIRED)
include_directories( ${CAIRO_INCLUDE_DIRS})
link_directories   ( ${CAIRO_LIBRARY_DIRS})

pkg_check_modules(X11 x11 REQUIRED)
include_directories( ${X11_INCLUDE_DIRS} )
link_directories   ( ${X11_LIBRARY_DIRS} )

IF(NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")
  SET(CMAKE_C_FLAGS   "-fPIC -msse -msse2 -mfpmath=sse -g") # -fsanitize=address
  SET(CMAKE_CXX_FLAGS "-fPIC -msse -msse2 -mfpmath=sse -g") # -fsanitize=address
ELSE()
    SET(CMAKE_C_FLAGS   "-fPIC -mfpu=neon -g")
    SET(CMAKE_CXX_FLAGS "-fPIC -mfpu=neon -g")
ENDIF(NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")

FILE(GLOB src libs/pffft.cxx avtk/*.cxx )

ADD_LIBRARY( avtk STATIC ${src} avtk/pugl/pugl_x11.c)
target_link_libraries( avtk LINK_PUBLIC ${CAIRO_LIBRARIES}  )

target_include_directories (avtk PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}" )

IF(AVTK_DEMO_AND_TEST)
  ADD_EXECUTABLE( avtkDemo test_ui.cxx main.cxx avtk/pugl/pugl_x11.c )
  FILE(GLOB testSrc tests/*.cxx)
  ADD_EXECUTABLE( avtkTests ${testSrc} avtk/pugl/pugl_x11.c )

  #target_link_libraries( avtk ${GL_LIBRARIES}     )
  target_link_libraries( avtkDemo avtk  )
  target_link_libraries( avtkDemo ${CAIRO_LIBRARIES}  )
  target_link_libraries( avtkDemo ${X11_LIBRARIES}    )

  target_link_libraries( avtkTests avtk  )
  target_link_libraries( avtkTests ${CAIRO_LIBRARIES}  )
  target_link_libraries( avtkTests ${X11_LIBRARIES}    )
  target_link_libraries( avtkTests ${SNDFILE_LIBRARIES}    )

  IF( AVTK_SNDFILE_SUPPORT )
    target_link_libraries( avtk ${SNDFILE_LIBRARIES}    )
  ENDIF()
ENDIF()

configure_file( "avtk/themes/default.avtk"  "default.avtk" COPYONLY)
configure_file( "avtk/themes/green.avtk"    "green.avtk"   COPYONLY)
configure_file( "avtk/themes/orange.avtk"   "orange.avtk"  COPYONLY)
configure_file( "avtk/themes/yellow.avtk"   "yellow.avtk"  COPYONLY)

=== PKGBUILD ===
# Maintainer: David Runge <dvzrv@archlinux.org>

pkgname=artyfx
pkgver=1.3.1
pkgrel=1
pkgdesc="A plugin bundle of artistic real-time audio effects"
arch=('x86_64')
url="http://openavproductions.com/artyfx/"
license=('GPL2')
groups=('lv2-plugins' 'pro-audio')
depends=('cairo' 'gcc-libs' 'glibc' 'libx11' 'lv2-host')
makedepends=('cmake' 'lv2' 'libsndfile')
source=("$pkgname-$pkgver.tar.gz::https://github.com/openAVproductions/openAV-${pkgname}/archive/release-${pkgver}.tar.gz")
sha512sums=('7fe84783f460e5ac62d715990a7140259b8e2f1e0a531cf6cde63dadfb51e934abd17c81a8c280699279c0af2aa74ee05e073d32539d99fa37d83a0b1cfc0c49')
b2sums=('cd858f64743529084130b5b4d8851ddddd8d69d8aada3a63e0634a41057390e858e5c5d7591fc45cea2c46644a6a3bd086d3ce5cac73bc61e94cd28f7046cc06')

prepare() {
  mv -v "openAV-ArtyFX-release-${pkgver}" "${pkgname}-${pkgver}"
}

build() {
  cd "$pkgname-$pkgver"
  cmake -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_BUILD_TYPE=None \
        -DBUILD_GUI=ON \
        -DBUILD_SSE=ON \
        -Wno-dev \
        -Bbuild \
        -S .
  make VERBOSE=1 -C build
}

package() {
  depends+=('libsndfile.so')
  cd "$pkgname-$pkgver"
  make DESTDIR="$pkgdir/" install -C build
  # docs
  install -vDm 644 {CHANGELOG,README.md} \
    -t "${pkgdir}/usr/share/doc/${pkgname}"
}
